var numtask;
var pref;
var strbundle, strbundle1;
var filters;
var filtersname;

function filterElement (index, caption, reg, check, link, image) {
	this.index = index;
	this.caption = caption;
	this.reg = reg;
	this.check = check;
	this.link = link;
	this.image = image;
}


function load () {

	pref = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefBranch);
	strbundle = document.getElementById("strings");
	strbundle1 = document.getElementById("strings1");

	if (document.getElementById("listafile").getRowCount() == 0) {
		document.getElementById("removebutton").disabled = true;
	}

	refreshlist();
}

function createFilter(index, caption, reg, check, link, image) {
	pref.setCharPref("extensions.dta.context.filter" + index + ".caption", caption);
	pref.setCharPref("extensions.dta.context.filter" + index + ".filter", reg);
	pref.setBoolPref("extensions.dta.context.filter" + index + ".checked", check);
	pref.setBoolPref("extensions.dta.context.filter" + index + ".isImageFilter", image);
	pref.setBoolPref("extensions.dta.context.filter" + index + ".isLinkFilter", link);
}

function refreshlist() {

	var list=document.getElementById('listafile');
	
	while (list.getRowCount() > 0) 
		list.removeChild(list.getItemAtIndex(0));
	
	// initialize arrays
	filters = new Array();
	
	try {
		var num = pref.getIntPref("extensions.dta.context.numfilters");
	} catch (e) {
		pref.setIntPref("extensions.dta.context.numfilters", 7);
		var num = 7;
		createFilter( 0, strbundle.getString("allfiles"), "/(\\.*)/", false, true, true );
		createFilter( 1, strbundle.getString("arch"), "/(\\.(z(ip|[0-9]{2})|r(ar|[0-9]{2})|jar|bz2|gz|tar|rpm))$/", false, true, false );
		createFilter( 2, strbundle.getString("vid"), "/(\\.(mpeg|rm|mpe|avi|mpg|mp4|mov|divx|asf|qt|wmv|ram|m1v|m2v|rv|vob|asx))$/", false, true, false );
		createFilter( 3, strbundle.getString("images"), "/(\\.(jpeg|jpg|gif|png|jpe|tif|tiff|bmp|ico))$/", false, true, false );
		createFilter( 4, "*.jpeg", "/(\\.(jpeg|jpg|jpe))$/", false, false, true );
		createFilter( 5, "*.gif", "/(\\.gif)$/", false, false, true );
		createFilter( 6, "*.png", "/(\\.png)$/", false, false, true );
	}

	for ( var i = 0; i < num; i++ ) 
		additem(
			pref.getCharPref("extensions.dta.context.filter" + i + ".caption"), 
			pref.getCharPref("extensions.dta.context.filter" + i + ".filter"), 
			pref.getBoolPref("extensions.dta.context.filter" + i + ".checked"),
			pref.getBoolPref("extensions.dta.context.filter" + i + ".isLinkFilter"),
			pref.getBoolPref("extensions.dta.context.filter" + i + ".isImageFilter")
		);
}
	

function add() {

	document.getElementById("removebutton").disabled = false;
	additem(strbundle.getString("newFilter"),strbundle.getString("ext"),false);
	changeProp();
}
	
function additem(caption,filter,checked, link, image) {
	
	var realnumfilters = document.getElementById("listafile").getRowCount();
	
	filters[realnumfilters] = new filterElement(realnumfilters, caption.replace(/\\/gi, "\\"), filter, checked, link, image);
	
	var listbox = document.getElementById("listafile");
	var child1 = document.createElement('listcell');
	child1.setAttribute('label',filters[realnumfilters].caption);
	var child2 = document.createElement('listcell');
	child2.setAttribute('label',filters[realnumfilters].reg);
	child1.setAttribute('id', "cap" + (realnumfilters));
	child2.setAttribute('id', "ext" + (realnumfilters));
	var item = document.createElement('listitem');
	item.appendChild(child1);
	item.appendChild(child2);
	listbox.appendChild(item);
	
	realnumfilters = document.getElementById("listafile").getRowCount();
	pref.setIntPref("extensions.dta.context.numfilters", realnumfilters);	
	
	document.getElementById("listafile").selectedIndex = (realnumfilters - 1);
}

function changeSelection() {
	
	var listbox = document.getElementById("listafile");
	document.getElementById("caption").value = filters[listbox.selectedIndex].caption;
	document.getElementById("captiongroup").label = filters[listbox.selectedIndex].caption;
	document.getElementById("filter").value = filters[listbox.selectedIndex].reg;
	document.getElementById("linksf").checked = filters[listbox.selectedIndex].link;
	document.getElementById("imagesf").checked = filters[listbox.selectedIndex].image;
	
	var filtertxt = document.getElementById("filter").value;
	if (filtertxt.substring(0,1) == "/" && filtertxt.substr(filtertxt.length - 1, 1) == "/" && filtertxt.length > 1)
		document.getElementById("regex").checked = true; else document.getElementById("regex").setAttribute("checked", false);
	
	if (document.getElementById("listafile").getRowCount() > 0) 
		document.getElementById("removebutton").disabled = false;
}

function remove() {

	var realnumfilters = document.getElementById("listafile").getRowCount();
	var listbox = document.getElementById("listafile");
	var selected = listbox.selectedIndex;
	listbox.removeChild(listbox.selectedItem);
	
	for (var i = selected + 1; i < realnumfilters; i++)
		filters[i - 1] = filters[i];
	
	realnumfilters--;
	pref.setIntPref("extensions.dta.context.numfilters", realnumfilters);
	
	for (var i = 0; i < realnumfilters; i++) {
		pref.setCharPref("extensions.dta.context.filter" + i + ".caption", filters[i].caption);
		pref.setCharPref("extensions.dta.context.filter" + i + ".filter", filters[i].reg);
		pref.setBoolPref("extensions.dta.context.filter" + i + ".checked", filters[i].check);
		pref.setBoolPref("extensions.dta.context.filter" + i + ".isLinkFilter", filters[i].link);
		pref.setBoolPref("extensions.dta.context.filter" + i + ".isImageFilter", filters[i].image);
	}
	
	if (selected >= realnumfilters) {listbox.selectedIndex = realnumfilters - 1;} else {listbox.selectedIndex = selected;}
	if (realnumfilters == 0) {document.getElementById("removebutton").disabled = true}
	
	refreshlist();
}
	
function defaults() {

	document.getElementById("removebutton").disabled = false;
	
	pref.deleteBranch("extensions.dta.context.numfilters");
	refreshlist();
}

function changeProp() {

	var listbox = document.getElementById("listafile");
	var i = listbox.selectedIndex;
	filters[i].caption = document.getElementById("caption").value;
	filters[i].reg = document.getElementById("filter").value;
	filters[i].link = document.getElementById("linksf").checked;
	filters[i].image = document.getElementById("imagesf").checked;
	document.getElementById("captiongroup").setAttribute("label", filters[i].caption);
	document.getElementById("ext" + i).setAttribute("label", filters[i].reg);
	document.getElementById("cap" + i).setAttribute("label", filters[i].caption);
	try{
	pref.setCharPref("extensions.dta.context.filter" + i + ".caption", filters[i].caption);
	pref.setCharPref("extensions.dta.context.filter" + i + ".filter", filters[i].reg);
	pref.setBoolPref("extensions.dta.context.filter" + i + ".checked", filters[i].check);
	pref.setBoolPref("extensions.dta.context.filter" + i + ".isLinkFilter", filters[i].link);
	pref.setBoolPref("extensions.dta.context.filter" + i + ".isImageFilter", filters[i].image);
	}catch (e) {alert(e);}
}

function makeRegex() {
	
	filtro = document.getElementById("filter");
	
	if (document.getElementById("regex").checked) {
	
		if (filtro.value.substring(0,1) != "/") filtro.value = "/" + filtro.value;
		if (filtro.value.substr(filtro.value.length - 1, 1) != "/") filtro.value = filtro.value + "/";
	
	} else {
	
		if (filtro.value.substring(0,1) == "/") filtro.value = filtro.value.substring(1, filtro.value.length);
		if (filtro.value.substr(filtro.value.length - 1, 1) == "/") filtro.value = filtro.value.substring(0, filtro.value.length -1);
	}
	
	changeProp();
}